#坦克大战

import pygame,time,random
_display = pygame.display
COLOR_BLACK = pygame.Color(0,0,0)
COLOR_RED = pygame.Color(255,0,0)
 version = "v1.25"

#主逻辑类
class MainGame():
    #游戏主窗口
    window = None
    SCREEN_HEIGHT = 500
    SCREEN_WIDTH = 800

    #创建我方坦克
    TANK_P1 = None
    #创建并存储敌方坦克
    EnemyTank_list = []
    #要创建的敌方坦克的数量
    EnemyTank_count = 5
    #存储我方子弹列表
    Bullet_list = []
    #存储敌方子弹列表
    Enemy_bullet_list = []
    #存储爆炸效果列表
    Explode_list = []
    #存储墙壁列表
    Wall_list = []

    #这里是基本范式，无用可删除
    def __init__(self):
        pass

    #开始游戏的方法
    def starGame(self):
        _display.init()
        #创建窗口加载窗口（借鉴官方文档：https://www.pygame.org/docs/ref/display.html）
        MainGame.window = _display.set_mode([MainGame.SCREEN_WIDTH,MainGame.SCREEN_HEIGHT])
        #创建我方坦克(调用我方坦克的方法)
        self.creatMyTank()
        #创建敌方坦克(调用敌方坦克方法)
        self.creatEnemyTank()
        #创建墙壁（调用墙壁的方法）
        self.creatWalls()

        #设置游戏标题
        _display.set_caption("坦克大战" + version)
        # self.getTextSurface("aaaa")
        #窗口持续刷新操作
        while True:
            #当前窗口的颜色
            MainGame.window.fill(COLOR_BLACK)
            #需要在循环中持续完成事件的获取，否则就是一次而已
            self.getEvent()
            #将绘制文字得到的小画布，粘贴到窗口中
            MainGame.window.blit(self.getTextSurface("剩余敌方坦克%d辆"%len(MainGame.EnemyTank_list)),(5,5))
            #循环展示墙壁的方法，（如果墙壁有生命值，需要展示仍然存活的墙壁）
            self.blitWalls()
            #循环展示我方坦克的调用，（必须存在对象，并且对象活着，才展示）
            if MainGame.TANK_P1 and MainGame.TANK_P1.live:
                # 将我方坦克加入到窗口中，坦克父类中的调用方法
                MainGame.TANK_P1.displayTank()
            else:
                del MainGame.TANK_P1
                MainGame.TANK_P1 = None
            #循环展示敌方坦克，在blitEnemyTank中调用了坦克父类中的调用方法
            self.blitEnemyTank()
            #调用坦克的移动方法（需要修改为根据坦克的开关状态来调用移动方法）
            if MainGame.TANK_P1 and not MainGame.TANK_P1.stop:
                MainGame.TANK_P1.move()
                #调用坦克碰撞墙壁的方法
                MainGame.TANK_P1.hitWalls()
                #调用我方坦克是否碰撞敌方坦克
                MainGame.TANK_P1.hitEnemyTank()
            #调用渲染子弹列表的一个方法
            self.blitBullet()
            #调用渲染敌方子弹有一个方法
            self.blitEnemyBullet()
            #调用展示爆炸效果的方法
            self.displayExplodes()
            #控制循环中窗口刷新的速度
            time.sleep(0.02)

            #当前窗口刷新
            _display.update()

    #创建我方坦克的方法（）
    def creatMyTank(self):
        #创建我方坦克
        MainGame.TANK_P1 = MyTank(400, 300)
        #创建音乐对象，载入我方坦克音乐
        music = Music("img/start.wav")
        #调用播放的方法
        music.play()

    #创建敌方坦克（）
    def creatEnemyTank(self):
        #把left放到for循环中去，让每次重新生成。
        top = 100
        for i in range(MainGame.EnemyTank_count):
            speed = random.randint(3, 6)
            left = random.randint(1, 7)
            eTank = EnemyTank(left*100,top,speed)
            MainGame.EnemyTank_list.append(eTank)

    #将敌方坦克加入到窗口中，坦克父类中的展示调用方法
    def blitEnemyTank(self):
        for eTank in MainGame.EnemyTank_list:
            if eTank.live:
                eTank.displayTank()  # 展示敌方画布加入窗口
                # 调用坦克的移动方法，(eTank.move())继承父类,这里不能继承。
                eTank.randMove()  # 随机移动
                #调用敌方坦克与墙壁的碰撞方法
                eTank.hitWalls()
                #调用敌方坦克是否碰撞我方坦克的方法
                eTank.hitMyTank()
                # 调用敌方坦克的射击方法
                eBullet = eTank.shot()
                # 如果子弹为None，则不加入敌方坦克子弹列表
                if eBullet:
                    # 将敌方子弹存储到敌方子弹列表
                    MainGame.Enemy_bullet_list.append(eBullet)
            else:
                MainGame.EnemyTank_list.remove(eTank)

    #创建墙壁的方法
    def creatWalls(self):
        for i in range(6):
            wall = Wall(140 * i,240)
            MainGame.Wall_list.append(wall)

    #将墙壁加入到窗口中，遍历墙壁，调用展示方法
    def blitWalls(self):
        for wall in MainGame.Wall_list:
            if wall.live:
                wall.displayWall()
            else:
                MainGame.Wall_list.remove(wall)

    #将我方子弹加入到窗口中，子弹类中的展示方法
    def blitBullet(self):
        for bullet in MainGame.Bullet_list:
            #如果子弹还活着，则绘制出来，否则，直接从列表中移除该子弹。
            if bullet.live:
                bullet.displayBullet()  # 展示我方子弹画布加入窗口
                # 调用子弹的移动方法，
                bullet.bulletMove()
                #调用我方子弹与敌方坦克的碰撞方法
                bullet.hitEnemyTank()
                #调用判断我方子弹是否碰撞墙壁的方法
                bullet.hitWalls()
            else:
                MainGame.Bullet_list.remove(bullet)

    #将敌方子弹加入到窗口中，子弹类中的展示方法
    def blitEnemyBullet(self):
        for eBullet in MainGame.Enemy_bullet_list:
            #如果子弹还活着，则绘制出来，否则，直接从列表中移除该子弹。
            if eBullet.live:
                eBullet.displayBullet()  # 展示我方子弹画布加入窗口
                # 调用子弹的移动方法，
                eBullet.bulletMove()
                #调用判断敌方子弹是否碰撞墙壁的方法
                eBullet.hitWalls()
                #我坦克消亡的方法调用
                if MainGame.TANK_P1 and MainGame.TANK_P1.live:
                    eBullet.hitMyTank()
            else:
                MainGame.Enemy_bullet_list.remove(eBullet)

    #新增方法，展示爆炸效果列表（爆炸图片由小及大展示）
    def displayExplodes(self):
        for explode in MainGame.Explode_list:
            if explode.live:
                explode.displayExplode()
            else:
                MainGame.Explode_list.remove(explode)

    #获取程序期间所有事件（鼠标事件，键盘事件）
    def getEvent(self):
        #获取所有的事件
        eventList = pygame.event.get()

        #对事件进行判断处理（如：点击关闭，和方向键的对应处理）
        for event in eventList:
            #判断事件类型是否为QUIT，（eventList=事件列表，enent=事件元素，event.type=事件类型）
            if event.type == pygame.QUIT:
                self.endGame()

            #判断事件类型是否为按键按下，方向键的对应处理
            if event.type == pygame.KEYDOWN:
                #print(event.key) #打印你按的按键。

                #按下ESC键让我方坦克重生，并且是我方坦克已经不存在的情况下
                if event.key == pygame.K_ESCAPE and not MainGame.TANK_P1:
                    #调用创建我方坦克的方法（让我方坦克重生）
                    self.creatMyTank()
                    # 创建爆炸音效，并调用音乐方法
                    music = Music("img/add.wav")
                    music.play()

                if MainGame.TANK_P1 and MainGame.TANK_P1.live:
                    # 方向按键的处理
                    if event.key == pygame.K_LEFT:
                        print("坦克向左调头，移动")
                        # 个性坦克的方向
                        MainGame.TANK_P1.direction = "L"
                        # 完成移动操作（调用坦克的移动方法）
                        # MainGame.TANK_P1.move()
                        MainGame.TANK_P1.stop = False
                    elif event.key == pygame.K_RIGHT:
                        print("坦克向右调头，移动")
                        # 个性坦克的方向
                        MainGame.TANK_P1.direction = "R"
                        # 完成移动操作（调用坦克的移动方法）
                        # MainGame.TANK_P1.move()
                        MainGame.TANK_P1.stop = False
                    elif event.key == pygame.K_UP:
                        print("坦克向上调头，移动")
                        # 个性坦克的方向
                        MainGame.TANK_P1.direction = "U"
                        # 完成移动操作（调用坦克的移动方法）
                        # MainGame.TANK_P1.move()
                        MainGame.TANK_P1.stop = False
                    elif event.key == pygame.K_DOWN:
                        print("坦克向下调头，移动")
                        # 个性坦克的方向
                        MainGame.TANK_P1.direction = "D"
                        # 完成移动操作（调用坦克的移动方法）
                        # MainGame.TANK_P1.move()
                        MainGame.TANK_P1.stop = False
                    elif event.key == pygame.K_SPACE:
                        print("发射子弹")
                        if len(MainGame.Bullet_list) < 3:
                            # 产生一颗子弹(我方子弹)
                            m = Bullet(MainGame.TANK_P1)
                            # 将子弹加入到子弹列表（我方子弹列表）
                            MainGame.Bullet_list.append(m)
                            #播放子弹射击的音乐，先创建对象，再调用方法
                            music = Music("img/fire.wav")
                            music.play()
                        else:
                            print("子弹数量不足。")
                        print("当前屏幕中的子弹数量为：%d" % len(MainGame.Bullet_list))

            #判断事件类型是否为按键松开，
            if event.type == pygame.KEYUP:
                #修改坦克的移动状态（限定仅仅是方向键松开，才修改移动状态）
                if event.key == pygame.K_LEFT or event.key == pygame.K_RIGHT or event.key == pygame.K_UP  \
                        or event.key == pygame.K_DOWN:
                    if MainGame.TANK_P1 and MainGame.TANK_P1.live:
                        MainGame.TANK_P1.stop = True

    #左上角提示条文字绘制功能
    def getTextSurface(self,text):
        #初始化字体模块
        pygame.font.init()
        #查看系统支持的所有字体
        # fontList = pygame.font.get_fonts()
        # print(fontList)
        #选择一个字体和设置颜色
        font = pygame.font.SysFont("kaiti",18)
        #使用对应的字符完成相关内容的绘制
        textSurface = font.render(text,True,COLOR_RED)
        return textSurface


    #结束游戏的方法
    def endGame(self):
        print("谢谢使用！")
        exit() #退出python解释器

#游戏引擎中的精灵类（碰撞逻辑）
class BaseItem(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)

#坦克类(父类)
class Tank(BaseItem):
    def __init__(self,left,top):
        self.images = {
            "U":pygame.image.load("img/p1tankU.gif"),
            "D":pygame.image.load("img/p1tankD.gif"),
            "L":pygame.image.load("img/p1tankL.gif"),
            "R":pygame.image.load("img/p1tankR.gif"),
        }
        self.direction = "U"
        self.image = self.images[self.direction]
        #坦克所在的区域 Rect-->
        self.rect = self.image.get_rect()
        #指定坦克初始化的位置，分别距离x,y轴的位置（我方坦克出现正下方，敌方随机分布）
        self.rect.left = left
        self.rect.top = top
        #新增加速度属性
        self.speed = 5
        #新增属性，坦克移动的开关
        self.stop = True
        #新增属性 live用来记录坦克是否活着
        self.live = True
        #新增属性，用来记录坦克移动之前的坐标（用于位置的还原）
        self.oldLeft = self.rect.left
        self.oldTop = self.rect.top

    #坦克移动的方法
    def move(self):
        # 先记录移动之前的坐标
        self.oldLeft = self.rect.left
        self.oldTop = self.rect.top
        if self.direction == "L":
            if self.rect.left > 0:
                self.rect.left -= self.speed
        elif self.direction == "R":
            if self.rect.left + self.rect.height < MainGame.SCREEN_WIDTH:
                self.rect.left += self.speed
        elif self.direction == "U":
            if self.rect.top > 0:
                self.rect.top -= self.speed
        elif self.direction == "D":
            if self.rect.top + self.rect.width < MainGame.SCREEN_HEIGHT:
                self.rect.top += self.speed

    #坐标还原方法，坦克遇到墙壁遇返回原来的坐标，坦克不能穿墙
    def stay(self):
        self.rect.left = self.oldLeft
        self.rect.top = self.oldTop

    #新增我方和敌方坦克碰撞墙壁的方法（撞墙返回，调用坐标还原方法）
    def hitWalls(self): #self是坦克自己，这是在坦克父类
        for wall in MainGame.Wall_list:
            if pygame.sprite.collide_rect(wall,self): #self是坦克自己，这是在坦克父类
                self.stay()

    #坦克射击的方法
    def shot(self):
        return Bullet(self)

    #展示坦克(将坦克这个小画布surface绘制到窗口中，blit())
    def displayTank(self):
        #1.重新设置坦克的图片
        self.image = self.images[self.direction]
        #2.将坦克加入到窗口中
        MainGame.window.blit(self.image,self.rect)

#坦克类（我方坦克）
class MyTank(Tank):
    def __init__(self,left,top):
        super(MyTank,self).__init__(left,top) #继承父类

    #新增我方坦克主动碰撞敌方坦克的方法（不能穿过坦克）
    def hitEnemyTank(self):
        for eTank in MainGame.EnemyTank_list:
            if pygame.sprite.collide_rect(eTank,self):
                self.stay()

#坦克类（敌方坦克）
class EnemyTank(Tank):
    def __init__(self,left,top,speed):
        #两种方案，调用父类，或者重写一个live属性。
        super(EnemyTank,self).__init__(left,top) #继承父类
        #self.live = True
        self.images = {
            "U":pygame.image.load("img/enemy1U.gif"),
            "D":pygame.image.load("img/enemy1D.gif"),
            "L":pygame.image.load("img/enemy1L.gif"),
            "R":pygame.image.load("img/enemy1R.gif"),
        }
        #敌方坦克出现的方向随机调用（randDirection）
        self.direction = self.randDirection()
        self.image = self.images[self.direction]
        #坦克所在的区域 Rect-->
        self.rect = self.image.get_rect()
        #指定坦克初始化的位置，分别距离x,y轴的位置（我方坦克出现正下方，敌方随机分布）
        self.rect.left = left
        self.rect.top = top
        #新增加速度属性
        self.speed = speed
        #新增属性，坦克移动的开关
        self.stop = True
        #新增频数属性，用来控制敌方坦克的随机移动
        self.step = 40

    #敌方坦克出现方向的随机该用方法
    def randDirection(self):
        num = random.randint(1,4)
        if num == 1:
            return "U"
        elif num == 2:
            return "D"
        elif num == 3:
            return "L"
        elif num == 4:
            return "R"

    #坦克的展示方法（继承父类,不写也可以。）
    # def displayEnemtTank(self):
    #     super().displayTank()

    #敌方坦克随机移动的方法
    def randMove(self):
        if self.step <= 0:
            self.direction = self.randDirection()
            self.step = 40
        else:
            self.move()
            self.step -= 1

    #重写敌方坦克子弹射击的方法
    def shot(self):
        num = random.randint(1,1000)
        if num <= 20:
            return Bullet(self)

    #新增敌方坦克主动碰撞我方坦克的方法（不能穿过坦克）
    def hitMyTank(self):
        #由于在MainGame的blitEnemyTank方法中eTank已经遍历，所以无须重复遍历
        if MainGame.TANK_P1 and MainGame.TANK_P1.live:
            if pygame.sprite.collide_rect(self,MainGame.TANK_P1): #self=eTank
                self.stay() #让敌方坦克停下来

#子弹类
class Bullet(BaseItem):
    def __init__(self,tank):
        #子弹图片的载入
        self.image = pygame.image.load("img/enemymissile.gif")
        #子弹的方向对应坦克的方向
        self.direction = tank.direction
        #获取图片所在的位置
        self.rect = self.image.get_rect()
        if self.direction == "U":
            self.rect.left = tank.rect.left + tank.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top - self.rect.height
        elif self.direction == "D":
            self.rect.left = tank.rect.left + tank.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top + tank.rect.height
        elif self.direction == "L":
            self.rect.left = tank.rect.left - self.rect.width / 2 - self.rect.width / 2
            self.rect.top = tank.rect.top + tank.rect.width / 2 - self.rect.width / 2
        elif self.direction == "R":
            self.rect.left = tank.rect.left + tank.rect.width
            self.rect.top = tank.rect.top + tank.rect.width / 2 - self.rect.width / 2
        #子弹的速度
        self.speed = 7
        #用来记录子弹是否活着？
        self.live = True



    #子弹的移动方法
    def bulletMove(self):
        if self.direction == "U":
            if self.rect.top > 0:
                self.rect.top -= self.speed
            else:
                #修改子弹存活状态的状态值
                self.live = False
        elif self.direction == "D":
            if self.rect.top < MainGame.SCREEN_HEIGHT - self.rect.height:
                self.rect.top += self.speed
            else:
                # 修改子弹存活状态的状态值
                self.live = False
        elif self.direction == "L":
            if self.rect.left > 0:
                self.rect.left -= self.speed
            else:
                # 修改子弹存活状态的状态值
                self.live = False
        elif self.direction == "R":
            if self.rect.left < MainGame.SCREEN_WIDTH - self.rect.width:
                self.rect.left += self.speed
            else:
                # 修改子弹存活状态的状态值
                self.live = False

    #展示子弹的方法
    def displayBullet(self):
        MainGame.window.blit(self.image,self.rect)

    #新增我方子弹碰撞敌方坦克的方法
    def hitEnemyTank(self):
        for eTank in MainGame.EnemyTank_list:
            if pygame.sprite.collide_rect(eTank,self):
                #产生一个爆炸效果
                explode = Explode(eTank)
                #将爆炸效果加入到爆炸效果列表
                MainGame.Explode_list.append(explode)
                # 创建爆炸音效，并调用音乐方法
                music = Music("img/blast.wav")
                music.play()
                self.live = False #self在子弹类，指的就是子弹，就是子弹的消亡。
                eTank.live = False

    #新增敌方子弹与我方坦克的碰撞方法
    def hitMyTank(self):
        if pygame.sprite.collide_rect(self,MainGame.TANK_P1):
            #产生爆炸效果，
            explode = Explode(MainGame.TANK_P1)
            #并加入到爆炸效果列表中
            MainGame.Explode_list.append(explode)
            #创建爆炸音效，并调用音乐方法
            music = Music("img/blast.wav")
            music.play()
            #修改子弹状态
            self.live = False #self在子弹类，指的就是子弹，就是子弹的消亡。
            #修改我方坦克的状态
            MainGame.TANK_P1.live = False

    #新增子弹与墙壁的碰撞，（就是子弹不能穿墙）
    def hitWalls(self):
        for wall in MainGame.Wall_list: #需要遍历每个墙壁
            if pygame.sprite.collide_rect(wall,self): #游戏引擎精灵类，（墙壁和子弹的碰撞）
                #修改子弹的状态，live属性，让子弹碰撞墙壁就消亡
                self.live = False #self在子弹类，指的就是子弹，就是子弹的消亡。
                wall.live -= 1 #碰撞一次，减去生命
                if wall.live <= 0:
                    wall.live = False #墙壁生命等于0，自动消亡。

#爆炸效果类
class Explode():
    def __init__(self,tank):
        self.rect = tank.rect
        self.step = 0
        self.images = [
            pygame.image.load("img/blast0.gif"),
            pygame.image.load("img/blast1.gif"),
            pygame.image.load("img/blast2.gif"),
            pygame.image.load("img/blast3.gif"),
            pygame.image.load("img/blast4.gif")
        ]
        self.image = self.images[self.step]
        self.live = True

    #展示爆炸效果(将爆炸画面加入到窗口中)
    def displayExplode(self):
        if self.step < len(self.images):
            MainGame.window.blit(self.image,self.rect)
            self.image = self.images[self.step]
            self.step += 1
        else:
            self.live = False
            self.step = 0

#墙壁类
class Wall():
    def __init__(self,left,top):
        self.image = pygame.image.load("img/steels.gif") #载入图片
        self.rect = self.image.get_rect() #获取图片坐标位置
        self.rect.left = left #指定left坐标位置
        self.rect.top = top #指定top坐标位置
        #用来判断墙壁是否应该在窗口中展示，（是否存活）
        self.live = True
        self.hp = 5  #用来记录墙壁的生命值，轰击几次才会死亡。


    #展示墙壁的方法
    def displayWall(self):
        #将墙壁的画面加入主窗口中，就是展示墙壁
        MainGame.window.blit(self.image,self.rect) #图片和位置加入到窗口中

#音效类
class Music():
    def __init__(self,fileName):
        self.fileName = fileName
        #先需要初始化混响器
        pygame.mixer.init()
        pygame.mixer.music.load(fileName)

    #开始播放音乐
    def play(self):
        pygame.mixer.music.play()

MainGame().starGame()